<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!--
IGAC proyecto SNC 
@author			pedro.garcia
@version 		2.0
@description	página en la que se seleccionan los datos que se van a modificar o complementar en
                una radicación
@cu 			CU-CO-R-01

OJO: 			hubo que usar dos form porque si no se hacía no entraba al método definido 
                en el primer commandButton

@modified		rodrigo.hernandez
                - actualización a tabla datosRectifComplDT con adición de funcionalidad para organizar datos y cambio de variable para carga de modelo de datos
                - actualización a picklist datosRectifComplPL con adición de titulos a las listas

@modified 		rodrigo.hernandez
                - adición de parametro currentManagedBeanParam para recibir bean que usa la pagina
                
@modified 		javier.aponte
                - adición de parametro tramiteParam para recibir el trámite como parametro
-->


<h:panelGrid id="rectifComplPG" 
             xmlns="http://www.w3.org/1999/xhtml"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:f="http://java.sun.com/jsf/core"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:p="http://primefaces.org/ui"
             width="100%">

    <p:messages id="msgsRC" showDetail="false" globalOnly="false"
                autoUpdate="false" />

    <h:form prependId="false" id="drcForm1">

        <h:panelGrid columns="2" width="100%" >
            <h:panelGroup>
                <h:outputLabel value="Tipo de rectificación o complementación: "
                               styleClass="outputLabelStyle" />
                <h:outputLabel value="* " styleClass="requiredLabelStyle" />
            </h:panelGroup>                    
            <h:selectOneMenu id="tipoRectif"
                             value="#{currentManagedBeanParam.tipoDatoRectifComplSeleccionado}"
                             rendered="#{tramiteParam.rectificacion}">
                <f:selectItems value="#{general.datoRectificarTipoV}" />
                <p:ajax immediate="true" update="datosRectifComplPL, :msgsRC"
                        onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
            </h:selectOneMenu>

            <h:selectOneMenu id="tipoCompl"
                             value="#{currentManagedBeanParam.tipoDatoRectifComplSeleccionado}"
                             rendered="#{!tramiteParam.rectificacion}">
                <f:selectItems value="#{general.datoComplementarTipoV}" />
                <p:ajax immediate="true" update="datosRectifComplPL, :msgsRC"
                        onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
            </h:selectOneMenu>
        </h:panelGrid>

        <p:spacer height="20" width="1" />


        <p:outputPanel layout="block" style="text-align: center;">
            <h:outputLabel value="Selección de datos para rectificar o complementar" 
                           styleClass="outputLabelStyle"/>
            <h:outputLabel value=" * " styleClass="requiredLabelStyle" />
        </p:outputPanel>

        <h:panelGrid width="100%" >
            <p:pickList id="datosRectifComplPL"
                        value="#{currentManagedBeanParam.datosRectifComplDLModel}" 
                        var="datoRC" 
                        converter="datoRectificarConverter" addLabel="Adicionar"
                        addAllLabel="Adicionar todos" removeLabel="Quitar"
                        removeAllLabel="Quitar todos" 
                        itemLabel="#{datoRC.nombre}"
                        itemValue="#{datoRC}" immediate="true"
                        valueChangeListener="#{currentManagedBeanParam.onRectifComplPLTransferListener}"
                        onTransfer="onTransferPickListRC(e);" >
                <f:facet name="sourceCaption" >Datos por seleccionar</f:facet>
                <f:facet name="targetCaption">Datos seleccionados</f:facet>

                <ui:remove>
                    Esto no sirve con esta versión de primefaces, pero sí con la siguiente. Es lo ideal para manejar la restricción de solo poder seleccionar un elemento escogido en algunos casos
                    <p:ajax event="transfer" 
                            listener="#{currentManagedBeanParam.onRectifComplPLTransferListener}" />
                </ui:remove>                
            </p:pickList>
        </h:panelGrid>

        <p:spacer height="7" width='0' />

        <p:outputPanel layout="block" style="text-align: left">
            <p:spacer height="0" width="13" />
            <p:commandButton value="Adicionar datos seleccionados"
                             icon="ui-icon-plus"
                             action="#{currentManagedBeanParam.adicionarDatosRectifCompl}"
                             update=":drcForm2:datosRectifComplDT, :msgsRC"
                             onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
        </p:outputPanel>

    </h:form>

    <h:form prependId="false" id="drcForm2">

        <p:spacer height="10" width="1" />

        <p:dataTable id="datosRectifComplDT"
                     selection="#{currentManagedBeanParam.selectedDatosRectifComplDT}"
                     selectionMode="multiple" rowKey="#{datoRectifComplTabla.id}"
                     emptyMessage="No se han adicionado datos para rectificar o complementar"
                     widgetVar="datosRectifComplDTWV"
                     value="#{currentManagedBeanParam.selectedDatosRectifComplDataTable}"
                     var="datoRectifComplTabla">
            <f:facet name="header">
                Datos por rectificar o complementar
            </f:facet>

            <p:column headerText="Tipo de rectificación"
                      sortBy="#{datoRectifComplTabla.tipo}">
                <h:outputText value="#{datoRectifComplTabla.tipo}" />
            </p:column>

            <p:column headerText="Dato" sortBy="#{datoRectifComplTabla.nombre}">
                <h:outputText value="#{datoRectifComplTabla.nombre}" />
            </p:column>
        </p:dataTable>

        <p:spacer height="20" width="13" />
        <p:outputPanel layout="block" style="text-align: left">
            <p:spacer height="0" width="13" />
            <p:commandButton value="Retirar datos" icon="ui-icon-minus"
                             onclick="if (datosRectifComplDTWV.selection.length === 0) {
                                         alert('Debe seleccionar al menos un dato para retirar');
                                         return false;
                                     }"
                             onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"
                             action="#{currentManagedBeanParam.retirarDatoRectifCompl}"
                             update="datosRectifComplDT, :msgsRC" immediate="false"
                             process="@this, datosRectifComplDT" />
            <p:spacer width="7" height="1" />
            <p:commandButton value="Aceptar" immediate="false"
                             icon="ui-icon-check"
                             action="#{currentManagedBeanParam.aceptarDatosARectificar}"
                             process="@this, datosRectifComplDT" onstart="statusDialog2.show();"
                             oncomplete="statusDialog2.hide();seleccionDatosRectificarWV.hide()"
                             update=":nuevoTramiteSolForm:tblDatosRectificarResumen, 
                             :msgsRC, :nuevoTramiteSolForm:msgsTramite, datosRectifComplDT" />

        </p:outputPanel>

    </h:form>
</h:panelGrid>